Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/Variable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/Variable.cs	(revision 9351)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.DecisionList/3.3/Variable/Variable.cs	(revision 9352)
@@ -76,4 +76,5 @@
     public override string ToString() {
       StringBuilder sb = new StringBuilder();
+      sb.Append(variableName + ": ");
       foreach (var attr in attributes) {
         if (attr) {
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Interfaces/IVariableVectorClassificationProblemData.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Interfaces/IVariableVectorClassificationProblemData.cs	(revision 9351)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Interfaces/IVariableVectorClassificationProblemData.cs	(revision 9352)
@@ -26,5 +26,5 @@
 namespace HeuristicLab.Encodings.VariableVector {
   public interface IVariableVectorClassificationProblemData : IConditionActionProblemData {
-    IFixedValueParameter<VariableVector> SampleVariableVectorParameter { get; }
+    IValueParameter<VariableVector> SampleVariableVectorParameter { get; }
     IFixedValueParameter<PercentValue> SpreadPercentageParameter { get; }
   }
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/AutoDefaultRule.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/AutoDefaultRule.cs	(revision 9351)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/AutoDefaultRule.cs	(revision 9352)
@@ -44,7 +44,4 @@
       get { return (ILookupParameter<ItemArray<DoubleValue>>)Parameters["Quality"]; }
     }
-    public ILookupParameter<ItemArray<IGAssistIndividual>> IndividualParameter {
-      get { return (ILookupParameter<ItemArray<IGAssistIndividual>>)Parameters["Individual"]; }
-    }
     public IValueLookupParameter<IntValue> AccuraciesCountParameter {
       get { return (IValueLookupParameter<IntValue>)Parameters["AccuraciesCount"]; }
@@ -70,9 +67,8 @@
       Parameters.Add(new ValueLookupParameter<ItemDictionary<IGAssistNiche, ItemList<DoubleValue>>>("AverageAccuracies"));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality"));
-      Parameters.Add(new ScopeTreeLookupParameter<IGAssistIndividual>("Individual"));
       Parameters.Add(new LookupParameter<IRandom>("Random"));
-      Parameters.Add(new ValueLookupParameter<IntValue>("AccuraciesCount"));
+      Parameters.Add(new ValueLookupParameter<IntValue>("AccuraciesCount", new IntValue(15)));
       Parameters.Add(new ValueLookupParameter<IGAssistNicheEqualityComparer>("NicheComparer"));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("NicheStandardDeviation"));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("NicheStandardDeviation", new DoubleValue(0.005)));
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -82,13 +78,26 @@
     public override IOperation Apply() {
       if (NichingParameter.ActualValue == null) {
+        IList<IGAssistNiche> niches = GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches().ToList();
         NichingParameter.ActualValue = new BoolValue(true);
-        NichesParameter.ActualValue = new IntValue(PossibleDefaultClassesParameter.ActualValue.Count);
-        AverageAccuraciesParameter.ActualValue = new ItemDictionary<IGAssistNiche, ItemList<DoubleValue>>(NicheComparerParameter.ActualValue);
-        foreach (var niche in PossibleDefaultClassesParameter.ActualValue) {
+        NichesParameter.ActualValue = new IntValue(niches.Count);
+        AverageAccuraciesParameter.ActualValue = new ItemDictionary<IGAssistNiche, ItemList<DoubleValue>>(NicheComparerParameter.ActualValue as IEqualityComparer<IGAssistNiche>);
+        foreach (var niche in GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches()) {
           AverageAccuracies.Add(niche, new ItemList<DoubleValue>(AccuraciesCount));
         }
+
+        int i = 0;
+        foreach (var individual in IndividualParameter.ActualValue) {
+          individual.SetNiche(RandomParameter.ActualValue, niches[i]);
+          i++;
+          i %= niches.Count;
+        }
+
+        OperationCollection next = new OperationCollection();
+        next.Add(EvaluateSubScopes());
+        next.Add(base.Apply());
+        return next;
       } else {
         var nicheFitness = new Dictionary<IGAssistNiche, double>(NicheComparerParameter.ActualValue);
-        foreach (var niche in PossibleDefaultClassesParameter.ActualValue) {
+        foreach (var niche in GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches()) {
           nicheFitness[niche] = 0.0;
           while (AverageAccuracies[niche].Count >= AccuraciesCount) {
@@ -105,9 +114,9 @@
         }
 
-        foreach (var niche in PossibleDefaultClassesParameter.ActualValue) {
+        foreach (var niche in GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches()) {
           AverageAccuracies[niche].Insert(0, new DoubleValue(nicheFitness[niche]));
         }
 
-        var averages = new List<double>(PossibleDefaultClassesParameter.ActualValue.Count);
+        var averages = new List<double>(GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches().Count());
         if (AverageAccuracies.Values.First().Count >= AccuraciesCount) {
           foreach (var averageAccuracy in AverageAccuracies.Values) {
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/DefaultRuleOperator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/DefaultRuleOperator.cs	(revision 9351)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/DefaultRuleOperator.cs	(revision 9352)
@@ -42,6 +42,12 @@
       get { return (IValueLookupParameter<IGAssistNiche>)Parameters["DefaultClass"]; }
     }
-    public ILookupParameter<ItemCollection<IGAssistNiche>> PossibleDefaultClassesParameter {
-      get { return (ILookupParameter<ItemCollection<IGAssistNiche>>)Parameters["PossibleDefaultClasses"]; }
+    public ILookupParameter<IGAssistNichesProblemData> GAssistNichesProblemDataParameter {
+      get { return (ILookupParameter<IGAssistNichesProblemData>)Parameters["GAssistNichesProblemData"]; }
+    }
+    public ILookupParameter<ItemArray<IGAssistIndividual>> IndividualParameter {
+      get { return (ILookupParameter<ItemArray<IGAssistIndividual>>)Parameters["Individual"]; }
+    }
+    public IValueLookupParameter<IOperator> EvaluatorParameter {
+      get { return (IValueLookupParameter<IOperator>)Parameters["Evaluator"]; }
     }
     #endregion
@@ -57,5 +63,18 @@
       Parameters.Add(new ValueLookupParameter<IntValue>("Niches"));
       Parameters.Add(new ValueLookupParameter<IGAssistNiche>("DefaultClass"));
-      Parameters.Add(new LookupParameter<ItemCollection<IGAssistNiche>>("PossibleDefaultClasses"));
+      Parameters.Add(new LookupParameter<IGAssistNichesProblemData>("GAssistNichesProblemData"));
+      Parameters.Add(new ScopeTreeLookupParameter<IGAssistIndividual>("Individual"));
+      Parameters.Add(new ValueLookupParameter<IOperator>("Evaluator"));
+    }
+
+    protected OperationCollection EvaluateSubScopes() {
+      IOperator evaluator = EvaluatorParameter.ActualValue;
+      OperationCollection evaluation = new OperationCollection();
+      if (evaluator != null) {
+        foreach (var subScope in ExecutionContext.Scope.SubScopes) {
+          evaluation.Add(ExecutionContext.CreateOperation(evaluator, subScope));
+        }
+      }
+      return evaluation;
     }
   }
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/IDefaultRuleOperator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/IDefaultRuleOperator.cs	(revision 9351)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/IDefaultRuleOperator.cs	(revision 9352)
@@ -26,7 +26,9 @@
   public interface IDefaultRuleOperator : IOperator {
     IValueLookupParameter<BoolValue> NichingParameter { get; }
-    ILookupParameter<IntValue> NichesParameter { get; }
-    IValueLookupParameter<Item> DefaultClassParameter { get; }
-    ILookupParameter<ItemCollection<IGAssistNiche>> PossibleDefaultClassesParameter { get; }
+    IValueLookupParameter<IntValue> NichesParameter { get; }
+    IValueLookupParameter<IGAssistNiche> DefaultClassParameter { get; }
+    ILookupParameter<IGAssistNichesProblemData> GAssistNichesProblemDataParameter { get; }
+    ILookupParameter<ItemArray<IGAssistIndividual>> IndividualParameter { get; }
+    IValueLookupParameter<IOperator> EvaluatorParameter { get; }
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/MajorDefaultRule.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/MajorDefaultRule.cs	(revision 9351)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/MajorDefaultRule.cs	(revision 9352)
@@ -77,5 +77,15 @@
           index = indices[0];
         }
-        DefaultClassParameter.ActualValue = PossibleDefaultClassesParameter.ActualValue.ElementAt(index);
+        IGAssistNiche niche = GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches().ElementAt(index);
+        DefaultClassParameter.ActualValue = niche;
+
+        foreach (var individual in IndividualParameter.ActualValue) {
+          individual.SetNiche(RandomParameter.ActualValue, niche);
+        }
+
+        OperationCollection next = new OperationCollection();
+        next.Add(EvaluateSubScopes());
+        next.Add(base.Apply());
+        return next;
       }
       return base.Apply();
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/MinorDefaultRule.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/MinorDefaultRule.cs	(revision 9351)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/DefaultRule/MinorDefaultRule.cs	(revision 9352)
@@ -77,5 +77,15 @@
           index = indices[0];
         }
-        DefaultClassParameter.ActualValue = PossibleDefaultClassesParameter.ActualValue.ElementAt(index);
+        IGAssistNiche niche = GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches().ElementAt(index);
+        DefaultClassParameter.ActualValue = niche;
+
+        foreach (var individual in IndividualParameter.ActualValue) {
+          individual.SetNiche(RandomParameter.ActualValue, niche);
+        }
+
+        OperationCollection next = new OperationCollection();
+        next.Add(EvaluateSubScopes());
+        next.Add(base.Apply());
+        return next;
       }
       return base.Apply();
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/IGAssistNichesProblemData.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/IGAssistNichesProblemData.cs	(revision 9352)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/IGAssistNichesProblemData.cs	(revision 9352)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  public interface IGAssistNichesProblemData : INamedItem {
+    IEnumerable<IGAssistNiche> GetPossibleNiches();
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/IGAssistProblem.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/IGAssistProblem.cs	(revision 9352)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/IGAssistProblem.cs	(revision 9352)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+namespace HeuristicLab.Optimization.Operators.LCS {
+  public interface IGAssistProblem : ISingleObjectiveHeuristicOptimizationProblem {
+    IParameter ProblemDataParameter { get; }
+    string NichingParameterName { get; }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistIndividual.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistIndividual.cs	(revision 9351)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistIndividual.cs	(revision 9352)
@@ -26,4 +26,5 @@
   public interface IGAssistIndividual : IItem {
     IGAssistNiche Niche { get; }
+    void SetNiche(IRandom random, IGAssistNiche niche);
     void ApplySplit(IRandom random, double probability);
     void ApplyMerge(IRandom random, double probability);
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistNiche.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistNiche.cs	(revision 9351)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistNiche.cs	(revision 9352)
@@ -20,4 +20,5 @@
 #endregion
 
+using System.Collections.Generic;
 using HeuristicLab.Core;
 
@@ -25,4 +26,6 @@
   public interface IGAssistNiche : IItem {
     bool SameNiche(IGAssistNiche niche);
+    int GetNicheHashCode();
+    IEqualityComparer<IGAssistNiche> Comparer { get; }
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/HeuristicLab.Optimization.Operators.LCS-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/HeuristicLab.Optimization.Operators.LCS-3.3.csproj	(revision 9351)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/HeuristicLab.Optimization.Operators.LCS-3.3.csproj	(revision 9352)
@@ -46,8 +46,4 @@
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
     </Reference>
-    <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Core-3.3.dll</HintPath>
-    </Reference>
     <Reference Include="HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
@@ -84,4 +80,5 @@
     <Reference Include="System" />
     <Reference Include="System.Core" />
+    <Reference Include="System.Drawing" />
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
@@ -92,4 +89,5 @@
   <ItemGroup>
     <Compile Include="DefaultRule\AutoDefaultRule.cs" />
+    <Compile Include="GAssist\IGAssistNichesProblemData.cs" />
     <Compile Include="DefaultRule\MajorDefaultRule.cs" />
     <Compile Include="DefaultRule\DefaultRuleOperator.cs" />
@@ -99,4 +97,5 @@
     <Compile Include="Discretizer\UniformWidthDiscretizer.cs" />
     <Compile Include="Discretizer\IDiscretizer.cs" />
+    <Compile Include="GAssist\IGAssistProblem.cs" />
     <Compile Include="GAssist\Interfaces\IGAssistIndividual.cs" />
     <Compile Include="GAssist\Interfaces\IGAssistIndividualCreator.cs" />
@@ -110,4 +109,5 @@
     <Compile Include="GAssist\SpecialStage\SplitOperator.cs" />
     <Compile Include="Plugin.cs" />
+    <Compile Include="Selection\INichingSingleObjectiveSelector.cs" />
     <Compile Include="Selection\NichingTournamentSelector.cs" />
     <Compile Include="Selection\PreservingRightReducer.cs" />
@@ -119,5 +119,10 @@
     <None Include="Plugin.cs.frame" />
   </ItemGroup>
-  <ItemGroup />
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{c36bd924-a541-4a00-afa8-41701378ddc5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/INichingSingleObjectiveSelector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/INichingSingleObjectiveSelector.cs	(revision 9352)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/INichingSingleObjectiveSelector.cs	(revision 9352)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  public interface INichingSingleObjectiveSelector : ISingleObjectiveSelector {
+    ILookupParameter<IGAssistNichesProblemData> GAssistNichesProblemDataParameter { get; }
+    ILookupParameter<BoolValue> NichingParameter { get; }
+    IValueLookupParameter<IntValue> ParentsPerChildParameter { get; }
+    ILookupParameter<ItemArray<IGAssistIndividual>> IndividualParameter { get; }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/NichingTournamentSelector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/NichingTournamentSelector.cs	(revision 9351)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/NichingTournamentSelector.cs	(revision 9352)
@@ -30,8 +30,8 @@
 using HeuristicLab.Selection;
 
-namespace HeuristicLab.Optimization.Operators.LCS.Selection {
+namespace HeuristicLab.Optimization.Operators.LCS {
   [Item("NichingTournamentSelector", "Description missing")]
   [StorableClass]
-  public class NichingTournamentSelector : StochasticSingleObjectiveSelector, ISingleObjectiveSelector {
+  public class NichingTournamentSelector : StochasticSingleObjectiveSelector, INichingSingleObjectiveSelector {
 
     #region Parameter Properties
@@ -39,6 +39,15 @@
       get { return (ValueLookupParameter<IntValue>)Parameters["GroupSize"]; }
     }
-    public LookupParameter<IntValue> NichesParameter {
-      get { return (LookupParameter<IntValue>)Parameters["Niches"]; }
+    public ILookupParameter<IGAssistNichesProblemData> GAssistNichesProblemDataParameter {
+      get { return (LookupParameter<IGAssistNichesProblemData>)Parameters["GAssistNichesProblemData"]; }
+    }
+    public ILookupParameter<BoolValue> NichingParameter {
+      get { return (LookupParameter<BoolValue>)Parameters["Niching"]; }
+    }
+    public IValueLookupParameter<IntValue> ParentsPerChildParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["ParentsPerChild"]; }
+    }
+    public ILookupParameter<ItemArray<IGAssistIndividual>> IndividualParameter {
+      get { return (ILookupParameter<ItemArray<IGAssistIndividual>>)Parameters["Individual"]; }
     }
     #endregion
@@ -52,5 +61,8 @@
       : base() {
       Parameters.Add(new ValueLookupParameter<IntValue>("GroupSize", "The size of the tournament group.", new IntValue(2)));
-      Parameters.Add(new LookupParameter<IntValue>("Niches", ""));
+      Parameters.Add(new LookupParameter<IGAssistNichesProblemData>("GAssistNichesProblemData", ""));
+      Parameters.Add(new LookupParameter<BoolValue>("Niching", ""));
+      Parameters.Add(new ValueLookupParameter<IntValue>("ParentsPerChild", ""));
+      Parameters.Add(new ScopeTreeLookupParameter<IGAssistIndividual>("Individual", ""));
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -64,33 +76,86 @@
       bool maximization = MaximizationParameter.ActualValue.Value;
       List<double> qualities = QualityParameter.ActualValue.Where(x => IsValidQuality(x.Value)).Select(x => x.Value).ToList();
+      List<IGAssistIndividual> individuals = IndividualParameter.ActualValue.ToList();
       int groupSize = GroupSizeParameter.ActualValue.Value;
       IScope[] selected = new IScope[count];
+      bool doNiching = NichingParameter.ActualValue.Value;
 
       //check if list with indexes is as long as the original scope list
       //otherwise invalid quality values were filtered
-      if (qualities.Count != scopes.Count) {
+      if (qualities.Count != scopes.Count && individuals.Count != scopes.Count) {
         throw new ArgumentException("The scopes contain invalid quality values (either infinity or double.NaN) on which the selector cannot operate.");
       }
 
-      for (int i = 0; i < count; i++) {
-        int best = random.Next(scopes.Count);
-        int index;
-        for (int j = 1; j < groupSize; j++) {
-          index = random.Next(scopes.Count);
-          if (((maximization) && (qualities[index] > qualities[best])) ||
-              ((!maximization) && (qualities[index] < qualities[best]))) {
-            best = index;
+      int parentsPerChild = ParentsPerChildParameter.ActualValue.Value;
+      var possibleNiches = GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches().ToList();
+      var selectPerNiche = new Dictionary<IGAssistNiche, int>(possibleNiches.First().Comparer);
+
+      var nicheScope = new Dictionary<IGAssistNiche, List<int>>(possibleNiches.First().Comparer);
+      foreach (var niche in possibleNiches) {
+        nicheScope.Add(niche, new List<int>());
+        selectPerNiche.Add(niche, count / possibleNiches.Count);
+      }
+
+      for (int i = 0; i < individuals.Count; i++) {
+        nicheScope[individuals[i].Niche].Add(i);
+      }
+
+      int curCount = 0;
+      while (curCount < count) {
+        IGAssistNiche niche = null;
+        int best = -1;
+        if (doNiching) {
+          niche = GetNiche(random, selectPerNiche, possibleNiches);
+        } else {
+          best = random.Next(scopes.Count);
+        }
+        for (int i = 0; i < parentsPerChild; i++) {
+          int index;
+          if (doNiching) {
+            best = nicheScope[niche][random.Next(nicheScope[niche].Count)];
           }
-        }
+          for (int j = 1; j < groupSize; j++) {
+            if (niche != null) {
+              index = nicheScope[niche][random.Next(nicheScope[niche].Count)];
+            } else {
+              index = random.Next(scopes.Count);
+            }
+            if (((maximization) && (qualities[index] > qualities[best])) ||
+                ((!maximization) && (qualities[index] < qualities[best]))) {
+              best = index;
+            }
+          }
 
-        if (copy)
-          selected[i] = (IScope)scopes[best].Clone();
-        else {
-          selected[i] = scopes[best];
-          scopes.RemoveAt(best);
-          qualities.RemoveAt(best);
+          niche = individuals[best].Niche;
+
+          if (copy)
+            selected[curCount] = (IScope)scopes[best].Clone();
+          else {
+            selected[curCount] = scopes[best];
+            scopes.RemoveAt(best);
+            qualities.RemoveAt(best);
+          }
+          selectPerNiche[niche]--;
+          curCount++;
         }
       }
+
       return selected;
+    }
+
+    private IGAssistNiche GetNiche(IRandom random, Dictionary<IGAssistNiche, int> nicheScope, List<IGAssistNiche> possibleNiches) {
+      int sum = nicheScope.Values.Sum();
+      if (sum <= 0) { return possibleNiches[random.Next(possibleNiches.Count)]; }
+      int pos = random.Next(sum);
+      int total = 0;
+      IGAssistNiche niche = nicheScope.Keys.First();
+      foreach (var item in nicheScope) {
+        total += item.Value;
+        niche = item.Key;
+        if (pos < total) {
+          return niche;
+        }
+      }
+      throw new ArgumentException("error in code");
     }
   }
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.CombinedIntegerVectorClassification/3.3/CombinedIntegerVectorClassificationProblemData.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.CombinedIntegerVectorClassification/3.3/CombinedIntegerVectorClassificationProblemData.cs	(revision 9351)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.CombinedIntegerVectorClassification/3.3/CombinedIntegerVectorClassificationProblemData.cs	(revision 9352)
@@ -45,6 +45,6 @@
       get { return (IFixedValueParameter<IntValue>)Parameters["ActionLength"]; }
     }
-    public IFixedValueParameter<IntMatrix> BoundsParameter {
-      get { return (IFixedValueParameter<IntMatrix>)Parameters["Bounds"]; }
+    public IValueParameter<IntMatrix> BoundsParameter {
+      get { return (IValueParameter<IntMatrix>)Parameters["Bounds"]; }
     }
     #endregion
@@ -77,5 +77,5 @@
       Parameters.Add(new FixedValueParameter<IntValue>("Length", "", new IntValue(allowedConditionVariables.Count() + allowedActionVariables.Count())));
       Parameters.Add(new FixedValueParameter<IntValue>("ActionLength", "", new IntValue(allowedActionVariables.Count())));
-      Parameters.Add(new FixedValueParameter<IntMatrix>("Bounds", "", GetBoundsMatrix(dataset, allowedConditionVariables, allowedActionVariables)));
+      Parameters.Add(new ValueParameter<IntMatrix>("Bounds", "", GetBoundsMatrix(dataset, allowedConditionVariables, allowedActionVariables)));
     }
 
@@ -126,4 +126,10 @@
       return (FetchInput(rowNumber) as IClassifier).Action;
     }
+
+    protected override void ActionConditionVariablesChanged() {
+      ActionLength.Value = AllowedActionVariables.Count();
+      Length.Value = AllowedConditionVariables.Count() + ActionLength.Value;
+      BoundsParameter.Value = GetBoundsMatrix(Dataset, AllowedConditionVariables, AllowedActionVariables);
+    }
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.CombinedIntegerVectorClassification/3.3/HeuristicLab.Problems.CombinedIntegerVectorClassification-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.CombinedIntegerVectorClassification/3.3/HeuristicLab.Problems.CombinedIntegerVectorClassification-3.3.csproj	(revision 9351)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.CombinedIntegerVectorClassification/3.3/HeuristicLab.Problems.CombinedIntegerVectorClassification-3.3.csproj	(revision 9352)
@@ -125,4 +125,13 @@
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd
+</PreBuildEvent>
+  </PropertyGroup>
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
        Other similar extension points exist, see Microsoft.Common.targets.
